#ifndef DECISIONTREE_H
#define DECISIONTREE_H
# include <discretedataset.h>
# include <tree.h>
class DecisionTree
{
private:
    /**
     * @brief mainTree, to basiko dentro
     */
    Tree *mainTree;
    /**
     * @brief trainSet, to dataset me ta dedomena ekpaideusis
     * @brief testSet, to dataset  me ta dedomena elegxou
     */
    DiscreteDataset *trainSet,*testSet;
public:
    /**
     * @brief DecisionTree, synartisi dimioyrgias tou dendrou apofasis
     * @param tr
     * @param tt
     */
    DecisionTree(DiscreteDataset *tr,DiscreteDataset *tt);
    /**
     * @brief train, ekpaideysi tou dendrou apofasis
     */
    void        train();
    /**
     * @brief getClass, epistrefei tin katigoria enos protypou
     * @param x
     * @return
     */
    QString     getClass(Pattern x);
    /**
     * @brief getTestError, epistrefei to sfalma sto test set.
     * @return
     */
    double      getTestError();
    /**
     * @brief subTree, dimiourgei ena neo dendro. Sto selectedFeatures
     * einai ta xaraktiristika pou exoyn epilegei.
     * @param selectedFeatures
     * @param dataset
     * @param feature
     * @return
     */
    Tree        *subTree(QVector<int> &selectedFeatures,DiscreteDataset *dataset,int feature);
    QString     followTree(Pattern x,Tree *T);
    ~DecisionTree();
};

#endif // DECISIONTREE_H
